Subject: Re: linux-next: manual merge of the rr tree

From: Rusty Russell <[email-masked]>
Date: Tue, 6 Jan 2009 11:34:48 +1030

On Tuesday 06 January 2009 01:59:28 Christoph Lameter wrote:
> On Mon, 5 Jan 2009, Rusty Russell wrote:
> 
> > 3) We do still need RELOC_HIDE: it's for the compiler, not us.  It
> >    can otherwise make assumptions about pointers remaining within objects.
> 
> Never heard about that one. If the compiler would make the assumption that
> pointers stay within a struct then the processor could hold data from
> another per cpu section in registers while writing to the per cpu variable
> of that per cpu section right?
> 
> But doesnt GCC invalidate all object pointers to a certain type of struct
> if one field is modified?

It was a Richard Henderson thing.  It was over six years ago, but I found
one decent reference to it:

	http://lwn.net/2002/0214/a/per-cpu.php3

Hope that answers your question?
Rusty.